diff -ur sourceold/scripts/jmgBearHunter.cpp source/scripts/jmgBearHunter.cpp
--- sourceold/scripts/jmgBearHunter.cpp	2019-06-22 07:43:44.237400000 +1000
+++ source/scripts/jmgBearHunter.cpp	2019-08-20 10:11:06.805000100 +1000
@@ -1163,6 +1291,7 @@
 	{
 		gameState = SecureBase;
 		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Kill all remaining mutants inside the walls!");
+		JmgUtility::Create_2D_Wave_Sound_Dialog("BH40.mp3");
 		objective = 12699;
 		JmgUtility::SetHUDHelpText(objective,Vector3(0,1,0));
 		NewObjectiveSystemControl.Set_Objective_Status(6,NewObjectiveSystem::Accomplished);
@@ -1193,6 +1322,7 @@
 		Commands->Start_Timer(obj,this,1.0f,5);
 		Commands->Start_Timer(obj,this,1.0f,15);
 		Commands->Start_Timer(obj,this,2.0f,15);
+		Commands->Start_Timer(obj,this,0.25f,19);
 	}
 	if (number == 5)
 	{
@@ -1204,11 +1334,14 @@
 			for (int x = 0;x < 128;x++)
 			{
 				GameObject *player = Get_GameObj(x);
-				if (JMG_Bear_Hunter_Game_Control::remainingLives[x]  && (!player || Get_Player_Type(player) != -4))
+				if (player && Commands->Get_Player_Type(player) == 1 && Commands->Get_Position(player).Z < 50.0f && _stricmp(Commands->Get_Preset_Name(player),"CNC_Spectator"))
 					isOver = false;
 			}
 			if (isOver && gameState == JMG_Bear_Hunter_Game_Control::BossArrive)
+			{
 				NewObjectiveSystemControl.Set_Objective_Status(12,NewObjectiveSystem::Failed);
+				playersDead = true;
+			}
 			winWait++;
 			if (winWait == 3)
 			{
@@ -1221,9 +1354,15 @@
 				if (!JMG_Bear_Hunter_Game_Control::hasBeenInjured)
 					spawnKarma += 2;
 				if (!JMG_Bear_Hunter_Game_Control::hasBeenInjured)
+				{
 					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: I cannot believe it; the president did not even get hurt once, if I did not know better, I would think you were cheating!");
+					JmgUtility::Create_2D_Wave_Sound_Dialog("BH41.mp3");
+				}
 				else
+				{
 					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Great work guys, I think thats all of them!");
+					JmgUtility::Create_2D_Wave_Sound_Dialog("BH42.mp3");
+				}
 			}
 			if (winWait == 13)
 			{
@@ -1243,7 +1382,10 @@
 				else
 					turretState = 2;
 				if (turretState)
+				{
 					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Just in time too, looks like the turret control computer was about to burn up. Shutting it down now...");
+					JmgUtility::Create_2D_Wave_Sound_Dialog("BH43.mp3");
+				}
 				if (0.7f < (1.0f*NewObjectiveSystemControl.Get_Objective_Priority_Count(NewObjectiveSystem::Secondary,NewObjectiveSystem::Accomplished)+NewObjectiveSystemControl.Get_Objective_Priority_Count(NewObjectiveSystem::Tertiary,NewObjectiveSystem::Accomplished)+NewObjectiveSystemControl.Get_Objective_Priority_Count(NewObjectiveSystem::Quaternary,NewObjectiveSystem::Accomplished))/(1.0f*NewObjectiveSystemControl.Get_Objective_Priority_Count(NewObjectiveSystem::Secondary)+NewObjectiveSystemControl.Get_Objective_Priority_Count(NewObjectiveSystem::Tertiary)+NewObjectiveSystemControl.Get_Objective_Priority_Count(NewObjectiveSystem::Quaternary)))
 					spawnKarma++;
 				if (JMG_Bear_Hunter_Power_Transformer::online && !JMG_Bear_Hunter_Game_Control::turretsDestroyed)
@@ -1307,11 +1449,20 @@
 			if (winWait == 23)
 			{
 				if (spawnKarma <= 1)
+				{
 					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Haha, its a good thing this isn't a video game, otherwise I'd have expected some sort of super mutant boss.");
+					JmgUtility::Create_2D_Wave_Sound_Dialog("BH44.mp3");
+				}
 				else if (spawnKarma <= 3)
+				{
 					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Haha, its a good thing this isn't a video game, otherwise I'd have expected some sort of super mutant boss, with maybe some support bosses because you did so well.");
+					JmgUtility::Create_2D_Wave_Sound_Dialog("BH45.mp3");
+				}
 				else
+				{
 					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: However, it is a good thing you people are not cheaters, otherwise karma would try to find a way to balance the odds.");
+					JmgUtility::Create_2D_Wave_Sound_Dialog("BH46.mp3");
+				}
 				Commands->Set_Lightning(1.0f,0.0f,0.25f,0.0f,1.0f,20.0f);
 				sprintf(currentSong,"304557_Goliath.mp3");
 			}
@@ -1320,6 +1471,7 @@
 			if (winWait == 43)
 			{
 				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Well, we should have seen this coming, hurry guys, kill it and we'll call it a day!");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH47.mp3");
 				Commands->Create_Object("Mutant_Rabbit_Boss",Vector3(0.0f,0.0f,0.0f));
 				if (spawnKarma >= 2)
 					for (int x = 0;x < spawnKarma;x++)
@@ -1373,6 +1525,7 @@
 			if (CheckIfPlayerInRange(switchPos,22500))
 			{
 				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: By the way, there is an active security system in the complex, you might want to deactivate it before you take the truck.");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH48.mp3");
 				NewObjectiveSystemControl.Add_Objective(14,NewObjectiveSystem::Quaternary,NewObjectiveSystem::Pending,12740,"",12740);
 				return;
 			}
@@ -1463,6 +1616,7 @@
 			if (entineersReturned == 5)
 			{
 				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Thats all of them, great work guys!");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH49.mp3");
 				NewObjectiveSystemControl.Set_Objective_Status(15,NewObjectiveSystem::Accomplished);
 			}
 			else
@@ -1472,12 +1626,14 @@
 				if (totalEngineers == 5)
 				{
 					sprintf(successMsg,"Bear Rug Co: Looks like we saved %d of the 5 engineers, it's good to see some of them back.",entineersReturned);
+					JmgUtility::Create_2D_Wave_Sound_Dialog("BH50.mp3");
 					JmgUtility::MessageAllPlayers(127,127,255,successMsg);
 					NewObjectiveSystemControl.Remove_Objective(15);
 				}
 				else
 				{
 					sprintf(successMsg,"Bear Rug Co: Good work bringing another engineer home, %d more to go.",5-totalEngineers);
+					JmgUtility::Create_2D_Wave_Sound_Dialog("BH51.mp3");
 					JmgUtility::MessageAllPlayers(127,127,255,successMsg);
 					unsigned int textId = (totalEngineers == 1) ? 12743 : (totalEngineers == 2) ? 12744 : (totalEngineers == 3) ? 12745 : 12746;
 					NewObjectiveSystemControl.Set_Objective_Mission(15,textId,textId);
@@ -1491,11 +1647,16 @@
 			lastUpdateEngineersDead = JMG_Bear_Hunter_Engineer_AI::engineersDead;
 			switch (JMG_Bear_Hunter_Engineer_AI::engineersDead)
 			{
-			case 1:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Looks like we lost an engineer.");break;
-			case 2:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Another engineer has died.");break;
-			case 3:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We've lost another engineer! Be more careful, these people have families!");break;
-			case 4:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Four engineers dead, maybe you should just let the last one hide.");break;
-			case 5:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We've lost all the engineers, I understand you guys didn't have training in fighting killer animals, but we still expected better.");break;
+			case 1:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Looks like we lost an engineer.");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH52.mp3");break;
+			case 2:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Another engineer has died.");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH53.mp3");break;
+			case 3:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We've lost another engineer! Be more careful, these people have families!");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH54.mp3");break;
+			case 4:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Four engineers dead, maybe you should just let the last one hide.");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH55.mp3");break;
+			case 5:JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We've lost all the engineers, I understand you guys didn't have training in fighting killer animals, but we still expected better.");
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH56.mp3");break;
 			}
 			int totalEngineers = entineersReturned+JMG_Bear_Hunter_Engineer_AI::engineersDead;
 			if (JMG_Bear_Hunter_Engineer_AI::engineersDead == 5)
@@ -1504,6 +1665,7 @@
 			{
 				char engineerMsg[220];
 				sprintf(engineerMsg,"Bear Rug Co: Looks like we saved %d of the 5 engineers, it's good to see some of them back.",entineersReturned);
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH50.mp3");
 				JmgUtility::MessageAllPlayers(127,127,255,engineerMsg);
 				NewObjectiveSystemControl.Remove_Objective(15);
 			}
@@ -1525,7 +1687,9 @@
 			if (JmgUtility::SimpleFlatDistance(Vector3(50.0f,-685.0f,0),Commands->Get_Position(player)) > 2500.0f)
 			{
 				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: While you are hunting for bears keep an eye out for weapons containers, 6 of them have been misplaced and we will let you use the weapons if you bring them back to base.");
-				NewObjectiveSystemControl.Add_Objective(18,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12772,"",12772,1);
+				JmgUtility::Create_2D_Wave_Sound_Dialog("BH57.mp3");
+				IncreaseBonusObjectiveCount(18);
+				NewObjectiveSystemControl.Add_Objective(18,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12772,"",12772,bonusObjectiveCount);
 				return;
 			}
 		}
@@ -1640,6 +1804,7 @@
 				Vector3 createPosition = posNode->position;
 				tinyDeer = Commands->Create_Object("Friendly_Tiny_Deer_Twiddler",createPosition);
 				Commands->Set_Player_Type(tinyDeer,1);
+				tinyDeer->As_SoldierGameObj()->Set_Override_Muzzle_Direction(true);
 				Commands->Attach_Script(tinyDeer,"JMG_Utility_AI_Goto_Enemy","75.0,1.5,1.0,0.0,1,1.5,-1.0,0.0,0,1.0,1,1.0,1,0,1,75.0");
 				Commands->Attach_Script(tinyDeer,"JMG_Bear_Hunter_Kill_Score_Tracker","");
 				MoveablePhysClass *mphys = tinyDeer->As_PhysicalGameObj() ? tinyDeer->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
@@ -1649,8 +1814,53 @@
 				JMG_Bear_Hunter_Game_Control::friendlyTinyDeerIds[x] = Commands->Get_ID(tinyDeer);
 				JMG_Bear_Hunter_Game_Control::friendlyTinyDeerRespawnTime[x] = 40;
 			}
+		if (gameTime && NewObjectiveSystemControl.Get_Objective_Status(25) == NewObjectiveSystem::Accomplished)
+			for (int x = 0;x < 8;x++)
+			{
+				if (wildMountainLionRespawn[x])
+					wildMountainLionRespawn[x]--;
+				if (wildMountainLionIds[x] && !Commands->Find_Object(wildMountainLionIds[x]))
+				{
+					wildMountainLionIds[x] = 0;
+					wildMountainLionRespawn[x] = 40;
+					continue;
+				}
+				if (wildMountainLionRespawn[x] || wildMountainLionIds[x])
+					continue;
+				Rp2SimplePositionSystem::SimplePositionNode *node = JMG_Wandering_AI_Controller::wanderPoints.GetRandomFromGroup(256);
+				if (!node)
+					continue;
+				GameObject *mlion = Commands->Create_Object("Normal_Mountain_Lion_Twiddler",node->position);
+				Vector3 pos = node->position;
+				MoveablePhysClass *mphys = mlion->As_PhysicalGameObj() ? mlion->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
+				if (mphys)
+					mphys->Find_Teleport_Location(pos,2.0f,&pos);
+				Commands->Set_Position(mlion,pos);
+				mlion->As_SoldierGameObj()->Set_Override_Muzzle_Direction(true);
+				Commands->Set_Player_Type(mlion,1);
+				Commands->Attach_Script(mlion,"JMG_Bear_Hunter_Friendly_Cougar","1.0,10.0,1.0,1.5,3.0,0.0,3,6,5.0");
+				wildMountainLionIds[x] = Commands->Get_ID(mlion);
+			}
 		Commands->Start_Timer(obj,this,0.25f,18);
 	}
+	if (number == 19)
+	{
+		Vector3 centerOfBase = Vector3(-0.532f,-705.389f,0.0f);
+		for (SLNode<SmartGameObj> *current = GameObjManager::SmartGameObjList.Head();current;current = current->Next())
+		{
+			SmartGameObj* o = current->Data();
+			Vector3 objectPos = Commands->Get_Position(o);
+			if (!o || Commands->Get_Player_Type(o) != 1 || !Commands->Get_Health(o) || Get_Vehicle(o))
+				continue;
+			float dist = JmgUtility::SimpleFlatDistance(objectPos,centerOfBase);
+			if ((dist > 27225.0f && objectPos.Z < 11.898f) || dist > 40000.0f)
+			{
+				bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(o))->DiedTryingToEscapeBase++;
+				Commands->Apply_Damage(o,1000.0f,"None",o);
+			}
+		}
+		Commands->Start_Timer(obj,this,0.25f,19);
+	}
 }
 void JMG_Bear_Hunter_Game_Control::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
@@ -1710,6 +1920,13 @@
 		GameObject *deerStatue = Commands->Find_Object(JMG_Bear_Hunter_Golden_Deer_Statue::statueId);
 		if (deerStatue)
 			Commands->Destroy_Object(deerStatue);
+		if (NewObjectiveSystemControl.Get_Objective_Status(25) != NewObjectiveSystem::Failed && NewObjectiveSystemControl.Get_Objective_Status(25) != NewObjectiveSystem::Accomplished)
+			for (int x = 0;x < 8;x++)
+			{
+				GameObject *mlion = Commands->Find_Object(wildMountainLionIds[x]);
+				if (mlion)
+					Commands->Destroy_Object(mlion);
+			}
 		GameObject *deerPlayer = Get_GameObj(JMG_Bear_Hunter_Golden_Deer_Statue::playerWithTheStatue);
 		if (deerPlayer)
 		{
@@ -1721,10 +1938,91 @@
 		}
 		if (NewObjectiveSystemControl.Get_Objective_Status(24) != NewObjectiveSystem::NotDefined && NewObjectiveSystemControl.Get_Objective_Status(24) != NewObjectiveSystem::Accomplished)
 		{
-			JmgUtility::MessageAllPlayers(127,127,255,"San Casina Rug Co: The statue has vanished, forget about it.");
+			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: The statue has vanished, forget about it.");
+			JmgUtility::Create_2D_Wave_Sound_Dialog("BH58.mp3");
 			NewObjectiveSystemControl.Set_Objective_Status(24,NewObjectiveSystem::Failed);
 		}
 	}
+	if (message == 268427)
+	{
+		if (param == 0)
+		{
+			if (NewObjectiveSystemControl.Get_Objective_Status(25) != NewObjectiveSystem::NotDefined)
+				return;
+			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Oh look, a pride of cougars... The boys bet that you guys can't pet them all, $50.00 per cat if you can!");
+			JmgUtility::Create_2D_Wave_Sound_Dialog("BH59.mp3");
+			IncreaseBonusObjectiveCount(25);
+			NewObjectiveSystemControl.Add_Objective(25,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12832,"",12832,bonusObjectiveCount);
+		}
+		else if (param == 1)
+		{
+			for (int x = 0;x < 8;x++)
+			{
+				GameObject *mlion = Commands->Find_Object(wildMountainLionIds[x]);
+				if (!mlion)
+					continue;
+				Remove_All_Scripts(mlion);
+				Commands->Set_Player_Type(mlion,0);
+				Commands->Attach_Script(mlion,"JMG_Utility_AI_Goto_Player","-1.0,1.0,1.0,0.0,0,1.0,-1.0,0.0,1,1.0,256,1.0,1,0,1,0.0,0.0,0,0,0,0,0,0,0,0.66");
+			}
+			if (NewObjectiveSystemControl.Get_Objective_Status(25) != NewObjectiveSystem::Pending)
+			{
+				bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(sender))->FailedPettingCougars++;
+				NewObjectiveSystemControl.Add_Objective(25,NewObjectiveSystem::Unknown,NewObjectiveSystem::Hidden,12832,"",12832,obj);
+				NewObjectiveSystemControl.Set_Objective_Status(25,NewObjectiveSystem::Failed);
+				return;
+			}
+			else if (NewObjectiveSystemControl.Get_Objective_Status(25) != NewObjectiveSystem::Failed)
+			{
+				bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(sender))->FailedPettingCougars++;
+				NewObjectiveSystemControl.Set_Objective_Status(25,NewObjectiveSystem::Failed);
+			}
+			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Looks like one died, now the bet is off!");
+			JmgUtility::Create_2D_Wave_Sound_Dialog("BH60.mp3");
+		}
+	}
+	if (message == 2684270)
+	{
+		if (NewObjectiveSystemControl.Get_Objective_Status(25) != NewObjectiveSystem::Pending)
+			return;
+		int pokerId = JmgUtility::JMG_Get_Player_ID(sender);
+		BearHunterScoreSystem::BHScoreNode *node = bearHunterScoreSystem.Get_Current_Player_Score_Node(pokerId);
+		node->PettedCougars++;
+		node->tmpPettedCougars++;
+		wildMountainLionsPet++;
+		GameObject *mlion = Commands->Find_Object(wildMountainLionIds[param]);
+		if (mlion)
+			Commands->Set_Player_Type(mlion,-2);
+		if (wildMountainLionsPet == 8)
+		{
+			for (int x = 0;x < 8;x++)
+			{
+				GameObject *mlion = Commands->Find_Object(wildMountainLionIds[x]);
+				if (!mlion)
+					continue;
+				Remove_All_Scripts(mlion);
+				Commands->Set_Player_Type(mlion,1);
+				Commands->Attach_Script(mlion,"JMG_Bear_Hunter_Friendly_Cougar","1.0,10.0,1.0,1.5,3.0,0.0,3,6,5.0");
+			}
+			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: I don't believe it! Those cougars look like they're your best friends now!");
+			JmgUtility::Create_2D_Wave_Sound_Dialog("BH61.mp3");
+			NewObjectiveSystemControl.Set_Objective_Status(25,NewObjectiveSystem::Accomplished);
+			for (int x = 1;x < 128;x++)
+			{
+				GameObject *player = Get_GameObj(x);
+				if (!player)
+					continue;
+				BearHunterScoreSystem::BHScoreNode *node = bearHunterScoreSystem.Get_Current_Player_Score_Node(x);
+				if (node->tmpPettedCougars)
+				{
+					Commands->Give_Points(player,50.0f*node->tmpPettedCougars,false);
+					node->BonusObjectivesCompleted++;
+				}
+			}
+		}
+		else
+			NewObjectiveSystemControl.Set_Objective_Mission(25,wildMountainLionsPet+12832,wildMountainLionsPet+12832);
+	}
 }
 void JMG_Bear_Hunter_Game_Control::Destroyed(GameObject *obj)
 {
@@ -1789,6 +2087,7 @@
 	}
 	weaponsUnlocked[6] = false;
 	aiPtLocations.Empty_List();
+	bossSpawnProtectionPoints.Empty_List();
 	if (saveData)
 		bearHunterScoreSystem.SaveData();
 	bearHunterScoreSystem.Cleanup();
@@ -1817,8 +2116,10 @@
 		preset = (Commands->Get_Random(0.0f,1.0f)<0.25) ? ((Commands->Get_Random(0.0,1.0f)<0.5f) ? (Commands->Get_Random(0.0f,1.0f) < 0.5f ? "Mutant_Squirrel_Twiddler" : "Mutant_Bear_Twiddler") : ((Commands->Get_Random(0.0,1.0f)<0.6) ? "Mutant_Cat" : "Mutant_Cat_Blue")) : ((Commands->Get_Random(0.0,1.0f)<0.5f) ? "Mutant_Deer_Twiddler" : "Mutant_Dog_Twiddler");
 	else if (gameTime > 150)// nuke cats
 		preset = (Commands->Get_Random(0.0f,1.0f)<0.25) ? ((Commands->Get_Random(0.0,1.0f)<0.5f) ? (Commands->Get_Random(0.0f,1.0f) < 0.5f ? "Mutant_Squirrel_Twiddler" : "Mutant_Bear_Twiddler") : ((Commands->Get_Random(0.0,1.0f)<0.6) ? "Mutant_Cat" : (Commands->Get_Random(0.0,1.0)<0.8) ? "Mutant_Cat_Blue" : "Mutant_Cat_Crazy")) : ((Commands->Get_Random(0.0,1.0f)<0.5f) ? "Mutant_Deer_Twiddler" : "Mutant_Dog_Twiddler");
+	else if (gameTime > 60)
+		preset = ((Commands->Get_Random(0.0,1.0f)<0.075f) ? "Mutant_Moose_Twiddler" : (Commands->Get_Random(0.0f,1.0f)<0.25) ? ((Commands->Get_Random(0.0,1.0f)<0.5f) ? (Commands->Get_Random(0.0f,1.0f) < 0.5f ? "Mutant_Squirrel_Twiddler" : "Mutant_Bear_Twiddler") : ((Commands->Get_Random(0.0,1.0f)<0.6) ? "Mutant_Cat" : (Commands->Get_Random(0.0,1.0)<0.8) ? "Mutant_Cat_Blue" : "Mutant_Cat_Crazy")) : ((Commands->Get_Random(0.0,1.0f)<0.5f) ? "Mutant_Deer_Twiddler" : "Mutant_Dog_Twiddler"));
 	else
-		preset = ((Commands->Get_Random(0.0,1.0f)<0.05f) ? "Mutant_Moose_Twiddler" : (Commands->Get_Random(0.0f,1.0f)<0.25) ? ((Commands->Get_Random(0.0,1.0f)<0.5f) ? (Commands->Get_Random(0.0f,1.0f) < 0.5f ? "Mutant_Squirrel_Twiddler" : "Mutant_Bear_Twiddler") : ((Commands->Get_Random(0.0,1.0f)<0.6) ? "Mutant_Cat" : (Commands->Get_Random(0.0,1.0)<0.8) ? "Mutant_Cat_Blue" : "Mutant_Cat_Crazy")) : ((Commands->Get_Random(0.0,1.0f)<0.5f) ? "Mutant_Deer_Twiddler" : "Mutant_Dog_Twiddler"));
+		preset = ((Commands->Get_Random(0.0,1.0f)<0.15f) ? (Commands->Get_Random(0.0f,1.0f)<0.5 ? "Mutant_Moose_Twiddler" : "Mutant_Mountain_Lion_Twiddler") : (Commands->Get_Random(0.0f,1.0f)<0.25) ? ((Commands->Get_Random(0.0,1.0f)<0.5f) ? (Commands->Get_Random(0.0f,1.0f) < 0.25f ? "Mutant_Squirrel_Twiddler" : "Mutant_Bear_Twiddler") : ((Commands->Get_Random(0.0,1.0f)<0.6) ? "Mutant_Cat" : (Commands->Get_Random(0.0,1.0)<0.8) ? "Mutant_Cat_Blue" : "Mutant_Cat_Crazy")) : ((Commands->Get_Random(0.0,1.0f)<0.5f) ? "Mutant_Deer_Twiddler" : "Mutant_Dog_Twiddler"));
 	Vector3 pos = BearHunterGameControlSystem.LookupNearestPosition(Vector2(Commands->Get_Random(-500.0f,500.0f),Commands->Get_Random(JmgUtility::MathClamp(CreatePositionZ-250,-600,500),CreatePositionZ)));
 	GameObject *ai = Commands->Create_Object(preset,pos);
 	Commands->Set_Facing(ai,Commands->Get_Random(-180,180));
@@ -1834,12 +2135,18 @@
 	mutantObjectListControl += ai;
 	char params[512];
 	sprintf(params,"%.2f",JmgUtility::MathClamp(JmgUtility::MathClamp(GamePercent*0.95f,0.35f,999.9f)+Commands->Get_Random(-0.1f,0.1f),0.35f,0.9f+Get_Player_Count()*0.0225f));
+	ai->As_SoldierGameObj()->Set_Override_Muzzle_Direction(true);
 	Attach_Script_Once(ai,"JMG_Bear_Hunt_Mutant_Attacker",params);
 	Attach_Script_Once(ai,"JMG_Bear_Hunter_Mutant_Tracker","");
 	Attach_Script_Once(ai,"JMG_Bear_Hunter_Animal_Control","");
 	Attach_Script_Once(ai,"JMG_Bear_Hunter_Mutant_Respawn_Tracker","");
 	return ai;
 }
+void JMG_Bear_Hunter_Game_Control::IncreaseBonusObjectiveCount(int objectiveId)
+{
+	if (NewObjectiveSystemControl.Get_Objective_Status(objectiveId) == NewObjectiveSystem::Undefined)
+		bonusObjectiveCount++;
+}
 void JMG_Rp2_Hostile_Mutant_AI::Created(GameObject *obj)
 {
 	damaged = false;
@@ -2415,13 +2722,15 @@
 	if (!(PlayerData.players[playerId]->killsWithoutGettingHurt % 10))
 	{
 		Commands->Give_Money(killer,50.0f,false);
-		JmgUtility::DisplayChatMessage(killer,11,194,255,"San Casina Rug Co: Congrats, here's your $50.00 for 10 in a row without being hurt!");
+		JmgUtility::DisplayChatMessage(killer,11,194,255,"Bear Rug Co: Congrats, here's your $50.00 for 10 in a row without being hurt!");
+		Create_2D_Wave_Sound_Dialog_Player(killer,"BH62.mp3");
 	}
 	PlayerData.players[playerId]->totalKills++;
 	if (!(PlayerData.players[playerId]->totalKills % 250))
 	{
 		Commands->Give_Money(killer,1000.0f,false);
-		JmgUtility::DisplayChatMessage(killer,11,194,255,"San Casina Rug Co: $1,000.00 for the 250 pelts!");
+		JmgUtility::DisplayChatMessage(killer,11,194,255,"Bear Rug Co: $1,000.00 for the 250 pelts!");
+		Create_2D_Wave_Sound_Dialog_Player(killer,"BH63.mp3");
 	}
 	if (Commands->Get_Random(0.0f,1.0f) < (1.0f-JMG_Bear_Hunter_Game_Control::gameTime/2000.0f)*0.25f)
 	{
@@ -2743,12 +3052,13 @@
 			playerScoreNode->ReturnedMedicalNeedle++;
 		JmgUtility::DisplayChatMessage(poker,200,127,255,"President of Corporate America: Thanks!");
 		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Good work, he'll feel better in no time!");
+		JmgUtility::Create_2D_Wave_Sound_Dialog("BH64.mp3");
 		for (int x = 1;x < 128;x++)
 		{
 			GameObject *player = Get_GameObj(x);
 			if (!player)
 				continue;
-			Commands->Give_Money(player,1000.0f,0);
+			Commands->Give_Money(player,100.0f,0);
 		}
 		const char *weap = Get_Current_Weapon(poker);
 		if (weap && !_stricmp(weap,"Weapon_Needle"))
@@ -2835,6 +3145,8 @@
 	Commands->Fade_Background_Music("Unreal2_awakening_Hell_Ending.mp3",1000,1000);
 	for (int x = 0;x < 5;x++)
 		Commands->Create_Sound("Mission_Failed",Commands->Get_Position(obj),obj);
+	JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We lost the President of Corporate America, our company is screwed!");
+	JmgUtility::Create_2D_Wave_Sound_Dialog("BH96.mp3");
 }
 void JMG_Bear_Hunter_President_Controller::damagedEvent(GameObject *obj,bool announce,bool palyinjured)
 {
@@ -2990,6 +3302,7 @@
 	if (JMG_Bear_Hunter_Game_Control::gameTime && JMG_Bear_Hunter_Game_Control::gameTime <= 700 && JMG_Bear_Hunter_Game_Control::objective != 12698 && JMG_Bear_Hunter_Game_Control::turretsDestroyed >= 5)
 	{
 		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: This is just getting to be too much, fall back and defend the President of Corporate America!");
+		JmgUtility::Create_2D_Wave_Sound_Dialog("BH65.mp3");
 		NewObjectiveSystemControl.Remove_Objective(5);
 		JmgUtility::SetHUDHelpText(JMG_Bear_Hunter_Game_Control::objective,Vector3(0,1,0));
 		JMG_Bear_Hunter_Game_Control::objective = 12698;
@@ -3000,6 +3313,7 @@
 	float compassDegree = atan2(turretPos.Y,turretPos.X)* (180.0f / PI);
 	char turretMsg[220];
 	sprintf(turretMsg,"Bear Rug Co: The %s Cannon Emplacement was destroyed!",JmgUtility::JMG_Get_Compass_Directions(compassDegree));
+	JmgUtility::Create_2D_Wave_Sound_Dialog("BH66.mp3");
 	JmgUtility::MessageAllPlayers(127,127,255,turretMsg);
 }
 void JMG_Powerup_Grant_Cash::Custom(GameObject *obj,int message,int param,GameObject *sender)
@@ -3061,15 +3375,15 @@
 		posNode = randomSelectableSpawnPoints[(PlayerData.players[JmgUtility::JMG_Get_Player_ID(obj)] && PlayerData.players[JmgUtility::JMG_Get_Player_ID(obj)]->deaths >= 5 && JMG_Bear_Hunter_Game_Control::spawnGroup == 1) ? 0 : JMG_Bear_Hunter_Game_Control::spawnGroup].GetRandomLowestValue();
 	else
 	{
-		float ranges[7] = {2500.0f,625.0f,625.0f,625.0f,625.0f,625.0f,625.0f};
+		float ranges[7] = {5625.0f,625.0f,625.0f,625.0f,625.0f,625.0f,625.0f};
 		float weight[7] = {1.0f,2.0f,2.0f,2.0f,2.0f,2.0f,2.0f};
 		Vector3 pos[7];
 		pos[0] = JMG_Bear_Hunt_Final_Boss::bossPos;
 		for (int x = 0;x < 6;x++)
 			pos[x+1] = Commands->Get_Position(Commands->Find_Object(JMG_Bear_Hunter_Game_Control::karmaDeerIds[x]));
-		posNode = randomSelectableSpawnPoints[JMG_Bear_Hunter_Game_Control::spawnGroup].GetSpotNotVisibileFromSpots(7,pos,ranges);
+		posNode = GetSpotNotVisibileFromSpots(7,pos,ranges);
 		if (!posNode)
-			posNode = randomSelectableSpawnPoints[JMG_Bear_Hunter_Game_Control::spawnGroup].GetFurthestSpotFromSpots(7,pos,weight);
+			posNode = GetFurthestSpotFromSpots(7,pos,weight);
 	}
 	if (!posNode)
 	{
@@ -3082,6 +3396,9 @@
 	if (mphys)
 		mphys->Find_Teleport_Location(pos,1.0f,&pos);
 	Commands->Set_Position(obj,pos);
+	char params[220];
+	sprintf(params,"0.1,%.2f",posNode->facing);
+	Commands->Attach_Script(obj,"JMG_Utility_Delay_Then_Rotate_Camera",params);
 }
 void JMG_Bear_Hunter_Player_Spawn::Timer_Expired(GameObject *obj,int number)
 {
@@ -3090,6 +3407,99 @@
 		Created(obj);
 	}
 }
+Rp2SimplePositionSystem::SimplePositionNode *JMG_Bear_Hunter_Player_Spawn::GetSpotNotVisibileFromSpots(int points,Vector3 pos[],float ranges[])
+{
+	for (int x = 0;x < points;x++)
+		pos[x].Z += 2;
+	Rp2SimplePositionSystem::SimplePositionNode *current = randomSelectableSpawnPoints[4].SimplePositionNodeList;
+	int random = Commands->Get_Random_Int(0,randomSelectableSpawnPoints[4].ObjectCount*2)+1;
+	int originalRandom = random;
+	while (current)
+	{
+		Vector3 targetpos = current->position;
+		targetpos.Z += 2.0f;
+		bool clear = true;
+		for (int x = 0;x < points;x++)
+		{
+			float dist = JmgUtility::SimpleDistance(pos[x],current->position);
+			if (dist < ranges[x])
+			{
+				clear = false;
+				break;
+			}
+			if ((!x || dist <= 14400.0f) && !TestRay(pos[x],targetpos))
+			{
+				clear = false;
+				break;
+			}
+			for (Rp2SimplePositionSystem::SimplePositionNode *currentSightNode = bossSpawnProtectionPoints.SimplePositionNodeList;currentSightNode;currentSightNode = currentSightNode->next)
+			{
+				if (currentSightNode->value != current->value)
+					continue;
+				if (!TestRay(pos[x],currentSightNode->position))
+				{
+					clear = false;
+					break;
+				}
+			}
+		}
+		if (clear)
+		{
+			if (random)
+				random--;
+			if (!random)
+				return current;
+		}
+		current = current->next;
+		if (!current && originalRandom != random)
+			current = randomSelectableSpawnPoints[4].SimplePositionNodeList;
+	}
+	return NULL;
+}
+Rp2SimplePositionSystem::SimplePositionNode *JMG_Bear_Hunter_Player_Spawn::GetFurthestSpotFromSpots(int points,Vector3 pos[],float weight[])
+{
+	float furthestDistance = 0;
+	Rp2SimplePositionSystem::SimplePositionNode *current = randomSelectableSpawnPoints[4].SimplePositionNodeList,*furthest = NULL;
+	while (current)
+	{
+		float tempBest = -1;
+		for (int x = 0;x < points;x++)
+		{
+			float tempDistance = JmgUtility::SimpleDistance(pos[x],current->position)*weight[x];
+			if (tempBest == -1 || tempDistance < tempBest)
+				tempBest = tempDistance;
+		}
+		if (furthestDistance < tempBest)
+		{
+			furthest = current;
+			furthestDistance = tempBest;
+		}
+		current = current->next;
+	}
+	return furthest;
+}
+bool JMG_Bear_Hunter_Player_Spawn::TestRay(Vector3 pos,Vector3 targetPos)
+{
+	CastResultStruct res;
+	LineSegClass ray(pos,targetPos);
+	PhysRayCollisionTestClass coltest(ray,&res,SOLDIER_GHOST_COLLISION_GROUP);
+	PhysicsSceneClass::Get_Instance()->Cast_Ray(coltest,false);
+	return coltest.CollidedRenderObj != NULL;
+}
+void JMG_Bear_Hunter_Player_Vehicle::Created(GameObject *obj)
+{
+	lastDamaged = 0;
+	Commands->Start_Timer(obj,this,0.1f,1); 
+}
+void JMG_Bear_Hunter_Player_Vehicle::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (lastDamaged)
+			lastDamaged--;
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
 void JMG_Bear_Hunter_Player_Vehicle::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
 	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
@@ -3102,6 +3512,11 @@
 		Commands->Set_Player_Type(obj,1);
 	}
 }
+void JMG_Bear_Hunter_Player_Vehicle::Damaged(GameObject *obj,GameObject *damager,float damage)
+{
+	if (damage > 0.0f)
+		lastDamaged = 150;
+}
 void JMG_Bear_Hunter_Player_Vehicle::Killed(GameObject *obj,GameObject *killer)
 {
 	bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(killer))->VehiclesDestroyed++;
@@ -3164,16 +3579,21 @@
 	{
 		NewObjectiveSystemControl.Set_Radar_Blip(10,obj);
 		JmgUtility::DisplayChatMessage(sender,127,127,255,"Bear Rug Co: Get back in that truck, it must make it back to base!");
+		Create_2D_Wave_Sound_Dialog_Player(sender,"BH67.mp3");
 	}
 	if (message == CUSTOM_EVENT_VEHICLE_ENTERED && (JMG_Bear_Hunter_Game_Control::gameTime > 775 || JMG_Bear_Hunter_Game_Control::truckTimeExtended) && !JMG_Bear_Hunter_Game_Control::hasGotTurrets)
 	{
 		if (NewObjectiveSystemControl.Get_Objective_Status(14) == NewObjectiveSystem::Pending)
 		{
 			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Looks like you forgot to deactivate the alarm, get out of there while you can, we're tracking lots of movement in the swamp!");
+			JmgUtility::Create_2D_Wave_Sound_Dialog("BH68.mp3");
 			NewObjectiveSystemControl.Set_Objective_Status(14,NewObjectiveSystem::Failed);
 		}
 		else
+		{
 			JmgUtility::DisplayChatMessage(sender,127,127,255,"Bear Rug Co: Now all you have to do is return the truck to base.");
+			Create_2D_Wave_Sound_Dialog_Player(sender,"BH69.mp3");
+		}
 		if (firstTime)
 		{
 			firstTime = false;
@@ -3194,7 +3614,10 @@
 		NewObjectiveSystemControl.Remove_Objective(9);
 		NewObjectiveSystemControl.Remove_Objective(10);
 		if (JMG_Bear_Hunter_Game_Control::gameTime > 775)
+		{
 			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: The truck was lost, GMax will pull another one out of the storage area for you shortly.");
+			JmgUtility::Create_2D_Wave_Sound_Dialog("BH70.mp3");
+		}
 	}
 }
 void JMG_Bear_Hunter_Security_Turret_Truck_Zone::Entered(GameObject *obj,GameObject *enterer)
@@ -3215,6 +3638,7 @@
 	if (JMG_Bear_Hunter_Game_Control::gameTime <= 775 && !JMG_Bear_Hunter_Game_Control::truckTimeExtended)
 	{
 		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Thanks for the turret parts, its too late for us to set up the turrets, but here is your payment!");
+		JmgUtility::Create_2D_Wave_Sound_Dialog("BH71.mp3");
 		return;
 	}
 	GameObject *driver = Get_Vehicle_Driver(obj);
@@ -3239,9 +3663,11 @@
 	Commands->Set_Facing(turret,90.0f);
 	Commands->Attach_Script(turret,"JMG_AI_Ignore_Object","");
 	JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Thanks for the turret parts, we'll get these up right away, and here is your payment!");
+	JmgUtility::Create_2D_Wave_Sound_Dialog("BH72.mp3");
 }
 void JMG_Bear_Hunt_Final_Boss::Created(GameObject *obj)
 {
+	targetIsMine = false;
 	moveSpeed = 0.5;
 	rabbitSize = 1.0f;
 	bossPos = Commands->Get_Position(obj);
